<template>
  <a-config-provider :locale="locale">
    <a-modal
      :title="`Копирование ${leadIds.length} сделок`"
      :visible="visible"
      :width="600"
      @ok="copy"
      @cancel="() => (visible = false)"
      okText="Скопировать"
      :okButtonProps="{ disabled: loading, loading: processing }"
    >
      <a-form v-if="!processing" layout="horizontal" :labelCol="{ span: 6 }" :wrapperCol="{ span: 18 }">
        <a-form-item label="Статус">
          <a-select
            v-model:value="payload.statusId"
            :options="statusOptions"
            optionFilterProp="label"
            showSearch
            :loading="loading"
          >
            <template #option="{ label, color }"> <a-badge :color="color" /> {{ label }} </template>
          </a-select>
        </a-form-item>
        <a-form-item label="Ответственный">
          <a-select v-model:value="payload.responsibleId" :options="userOptions" optionFilterProp="label" showSearch>
            <template #option="{ label, avatar }">
              <a-avatar :src="avatar" :size="20" style="margin-right: 5px" />
              {{ label }}
            </template>
          </a-select>
        </a-form-item>
        <a-form-item label="Поля">
          <a-tree-select
            v-model:value="payload.customFields"
            :treeData="customFieldsTree"
            multiple
            showSearch
            allowClear
            treeCheckable
            :maxTagCount="0"
            :maxTagPlaceholder="value => `Выбрано ${value.length} полей`"
            treeNodeFilterProp="title"
            :loading="loading"
          />
        </a-form-item>
        <a-form-item label="Дополнительно">
          <a-checkbox v-model:checked="payload.budget">Бюджет</a-checkbox>
          <a-checkbox v-model:checked="payload.linkedEntites">Связанные сущности</a-checkbox>
        </a-form-item>
      </a-form>
      <a-progress v-else :percent="progress" :status="progress >= 100 ? 'success' : 'active'" :showInfo="false" />
    </a-modal>
  </a-config-provider>
</template>

<script lang="ts">
  import { ConfigProvider, Avatar, Badge, Modal, Form, Checkbox, Select, TreeSelect, Progress } from 'ant-design-vue'
  import locale from 'ant-design-vue/es/locale/ru_RU'
  import { defineComponent, getCurrentInstance } from 'vue'
  import axios from 'axios'
  import _ from 'lodash'
  import { eachLimit, asyncify } from 'async'
  import delay from 'delay'

  export default defineComponent({
    setup() {
      const { app } = getCurrentInstance().appContext
      app.use(ConfigProvider)
      app.use(Avatar)
      app.use(Badge)
      app.use(Modal)
      app.use(Form)
      app.use(Checkbox)
      app.use(Select)
      app.use(TreeSelect)
      app.use(Progress)
    },
    props: {
      leadIds: Array,
      api: Object
    },
    data() {
      return {
        locale,
        visible: true,
        loading: true,
        processing: false,
        requestId: null,
        progress: 0,
        payload: {
          statusId: null,
          responsibleId: AMOCRM.constant('user').id,
          customFields: [],
          budget: true,
          linkedEntites: true
        },
        userOptions: (() => {
          const managers = AMOCRM.constant('managers')
          const managersArray: any[] = Object.values(managers)
          return managersArray.map(u => ({
            label: u.title,
            avatar: u.avatar,
            value: Number(u.id)
          }))
        })(),
        customFieldsTree: [],
        statusOptions: []
      }
    },
    methods: {
      async copy() {
        this.processing = true

        const {
          data: { requestId }
        } = await this.api.post('/copy', {
          leadIds: this.leadIds,
          payload: this.payload
        })

        this.requestId = requestId
        this.check()

        // await eachLimit(
        //   _.chunk(this.leadIds, 5),
        //   2,
        //   asyncify(async ids => {
        //     await axios.post('https://webhook.site/f73b4ff6-2ca2-4941-8aee-c6f528bc4282', {
        //       leadIds: ids,
        //       payload: this.payload
        //     })
        //     await delay(_.random(100, 500))

        //     this.progress += (ids.length / this.leadIds.length) * 100
        //   })
        // )
      },
      async check() {
        await delay(1000)

        const {
          data: { progress }
        } = await this.api.get('/copy/check', {
          params: { requestId: this.requestId }
        })

        this.progress = progress
        if (progress === 100) {
          await delay(1000)
          this.visible = false
        } else {
          this.check()
        }
      },
      async getStatuses() {
        const { pipelines } = await axios.get('/api/v4/leads/pipelines').then(({ data }) => data._embedded)

        this.statusOptions = pipelines.map(pipeline => ({
          label: pipeline.name,
          options: _.sortBy(pipeline._embedded.statuses, 'sort')
            .filter(({ type }) => !type)
            .map(status => {
              const statusId = `${pipeline.id}_${status.id}`
              if (!this.payload.statusId) this.payload.statusId = statusId
              return {
                label: status.name,
                value: statusId,
                color: status.color
              }
            })
        }))
      },
      async getCustomFields() {
        const [fields, groups] = await Promise.all([
          axios
            .get('/api/v4/leads/custom_fields', {
              params: { limit: 250 }
            })
            .then(({ data }) => data._embedded.custom_fields),
          axios
            .get('/api/v4/leads/custom_fields/groups', {
              params: { limit: 250 }
            })
            .then(({ data }) => data._embedded.custom_field_groups)
        ])

        this.customFieldsTree = groups
          .filter(group => group.fields.length || group.id === 'default')
          .map(group => ({
            title: group.name,
            value: group.id,
            children: fields
              .filter(field => {
                const groupId = [null, '', 0].includes(field.group_id) ? 'default' : field.group_id
                if (groupId === group.id) {
                  this.payload.customFields.push(field.id)
                  return true
                }
              })
              .map(field => ({ title: field.name, value: field.id }))
          }))
      }
    },
    async created() {
      await Promise.all([this.getCustomFields(), this.getStatuses()])
      this.loading = false
    }
  })
</script>

<style scoped>
  .ant-row {
    margin-bottom: 10px;
  }
</style>
